<#ibiztemplate>
TARGET=PSDEDBTABLE
</#ibiztemplate>
package ${pub.getPKGCodeName()}.mybatis.${de.getPSSystemModule().getCodeName()?lower_case}.po;

import ${pub.getPKGCodeName()}.core.repository.po.${de.getCodeName()};
import com.baomidou.mybatisplus.annotation.*;
import com.fasterxml.jackson.annotation.JsonIgnore;
import java.io.Serializable;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import ${pub.getPKGCodeName()}.util.annotation.PreField;
import ${pub.getPKGCodeName()}.util.enums.FillMode;
import ${pub.getPKGCodeName()}.util.enums.PredefinedType;

/**
 * 关系型数据实体表[${de.getCodeName()}] 对象
 */
@TableName(value = "${item.name}",resultMap = "${item.name}ResultMap")
public class ${item.name}Impl implements ${de.getCodeName()},Serializable {

    <#list de.getAllPSDEFields()  as defield>
    <#if defield.isPhisicalDEField()>
        <#if defield.getPSSysDBColumn()??>
    <#comment>---字段注释---</#comment>
    /**
     * [${defield.getLogicName()}]
     */
    <#comment>---字段注释---</#comment>
    <#comment>主键</#comment>
    <#if defield.isKeyDEField()==true>
    @TableId(value= "${defield.getName()?lower_case}",type=IdType.UUID)
    </#if>
    <#comment>系统预置属性</#comment>
    <#if  defield.getPredefinedType?? && defield.getPredefinedType()??>
        <#comment>逻辑有效属性（若实体中已配置逻辑有效值，则以配置为主，否则走yml中的全局默认值）</#comment>
        <#if defield.getPredefinedType()?lower_case =='logicvalid' && de.getLogicValidPSDEField()?? && de.isLogicValid()==true>
            <#if (((item.getValidLogicValue())!'')!='')  && (((item.getInvalidLogicValue())!'')!='')>
    @TableLogic(value= "${item.getValidLogicValue()}",delval="${item.getInvalidLogicValue()}")
            <#else>
    @TableLogic
            </#if>
        </#if>
        <#comment>系统预置属性</#comment>
        <#if defield.getPredefinedType()?lower_case =='createman' >
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
        <#elseif defield.getPredefinedType()?lower_case =='createmanname'>
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMANNAME)
        <#elseif defield.getPredefinedType()?lower_case =='updateman'>
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
        <#elseif defield.getPredefinedType()?lower_case =='updatemanname'>
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMANNAME)
        <#elseif defield.getPredefinedType()?lower_case =='createdate'>
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
        <#elseif defield.getPredefinedType()?lower_case =='updatedate'>
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
        <#elseif defield.getPredefinedType()?lower_case =='orgid'>
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.ORGID)
        <#elseif defield.getPredefinedType()?lower_case =='orgname'>
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.ORGNAME)
        <#elseif defield.getPredefinedType()?lower_case =='orgsectorid'>
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.ORGSECTORID)
        <#elseif defield.getPredefinedType()?lower_case =='orgsectorname'>
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.ORGSECTORNAME)
        </#if>
    </#if>
    private ${srfjavatype(defield.stdDataType)} ${defield.codeName?uncap_first};
    /**
     * [${defield.getLogicName()}]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean ${defield.getCodeName()?uncap_first}DirtyFlag;
        </#if>
    <#else>
    @TableField(exist = false)
    private ${srfjavatype(defield.stdDataType)} ${defield.codeName?uncap_first};
    /**
     * [${defield.getLogicName()}]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean ${defield.getCodeName()?uncap_first}DirtyFlag;
    </#if>

    </#list>
    <#list de.getAllPSDEFields() as defield>
    /**
     * 获取 [${defield.getLogicName()}]
     */
    public ${srfjavatype(defield.getStdDataType())} get${defield.getCodeName()?cap_first}(){
    <#if defield.isPhisicalDEField()>
        <#if defield.getPSSysDBColumn()??>
        return this.${defield.getCodeName()?uncap_first} ;
        <#else>
        return null ;
        </#if>
    <#else>
        return this.${defield.getCodeName()?uncap_first} ;   
    </#if>    
    }

    /**
     * 设置 [${defield.getLogicName()}]
     */
    public void set${defield.getCodeName()?cap_first}(${srfjavatype(defield.getStdDataType())}  ${defield.getCodeName()?uncap_first}){
    <#if defield.isPhisicalDEField()>
        <#if defield.getPSSysDBColumn()??>
        this.${defield.getCodeName()?uncap_first} = ${defield.getCodeName()?uncap_first} ;
        this.${defield.getCodeName()?uncap_first}DirtyFlag = true ;
        </#if>
    <#else>
        this.${defield.getCodeName()?uncap_first} = ${defield.getCodeName()?uncap_first} ;
        this.${defield.getCodeName()?uncap_first}DirtyFlag = true ;
    </#if>
    }

    /**
     * 获取 [${defield.getLogicName()}]脏标记
     */
    @JsonIgnore
    public boolean get${defield.getCodeName()?cap_first}DirtyFlag(){
    <#if defield.isPhisicalDEField()>
        <#if defield.getPSSysDBColumn()??>
        return this.${defield.getCodeName()?uncap_first}DirtyFlag ;
        <#else>
        return false ;
        </#if>
    <#else>
        return this.${defield.getCodeName()?uncap_first}DirtyFlag ;
    </#if>    
    }
    </#list>
}